BEGIN{
    hex[0] = 0;     hex[1] = 1;     hex[2] = 2;     hex[3] = 3;
    hex[4] = 4;     hex[5] = 5;     hex[6] = 6;     hex[7] = 7;
    hex[8] = 8;     hex[9] = 9;     hex["A"] = 10;  hex["B"] = 11;
    hex["C"] = 12;  hex["D"] = 13;  hex["E"] = 14;  hex["F"] = 15;
}
{
	sum = 0;
	len = hex2dec($1, 2);
	sum += len;
	x = hex2dec($1, 4);
	sum += x;
	addr = hex2dec($1, 6);
	sum += addr;
	addr += x * 256;
	rtype = hex2dec($1, 8);
	sum += rtype;
	for (i=0; i<len; i++) {
		data[i] = hex2dec($1, 10+i*2);
		sum += data[i];
	}
	isum = hex2dec($1, 10+len*2);
	sum += isum;
	sum = sum % 256;
	if (sum != 0) {
		printf("line %d: ihex format error!\n",NR);
		exit(1);
	}
	if (NR == 1) {
		if (data[0] == 12 && data[1] == 9 * 16 + 4) {
		    addr = 0;
		    #len = 4;
		} else {
		    printf("line %d: data error!\n",NR);
		    exit(1);
	        }
	}
	if (NR == 1 || rtype == 1) {
		print_ihex(rtype, addr, data, len);
	}
}

function hex2dec(str, i, x) {
    x = hex[substr(str,i,1)] * 16 + hex[substr(str,i+1,1)];
    return x;
}

function print_ihex(rtype, addr, data, len, sum) {
	sum = 0;
	printf(":%02X%04X%02X",len, addr, rtype);
	sum += len;
	sum += addr;
	sum += int(addr/256);
	sum += rtype;
	for (i=0; i<len; i++) {
		printf("%02X", data[i]);
		sum += data[i];
	}
	sum = sum % 256;
	printf("%02X\r\n", 256 - sum);
	return sum;
}
