#ifndef _BUTTON_H
#define _BUTTON_H

#define ENABLE_PORT	PORTC
#define ENABLE_DDR	DDRC
#define ENABLE_BIT	PC2

#define PIN_BUTTON	PIND

uint8_t button_state;
static uint8_t raw_button_state[8];

uint8_t check_button() {
	uint8_t *p;
	int8_t i;

	bit_set(ENABLE_PORT, ENABLE_BIT);
	bit_set(ENABLE_DDR, ENABLE_BIT);
	_delay_us(1);
	p = raw_button_state;
	for (i=0; i<8; i++,p++) {
		*p <<= 1;
		if (bit_is_set(PIN_BUTTON,i)) {
			*p |= 1;
		}
		if (*p == 0) {
			bit_clear(button_state,i)
		} else if (*p == 0xff) {
			bit_set(button_state,i)
		}
	}
	bit_clear(ENABLE_DDR, ENABLE_BIT);
	bit_clear(ENABLE_PORT, ENABLE_BIT);
	return button_state;
}
#endif /* _BUTTON_H */
